// Sock.cpp: CSock NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "IB.h"
#include "Sock.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//
// O		:CSock::CSock()
// @\		:ftHgRXgN^
// 		:Ȃ
// ߂l	:Ȃ
//
CSock::CSock()
{
	m_hSocket = INVALID_SOCKET;
}

//
// O		:CSock::~CSock()
// @\		:fXgN^
// 		:Ȃ
// ߂l	:Ȃ
//
CSock::~CSock()
{

}

//
// O		:void CSock::Attach( SOCKET hSocket )
// @\		:\Pbgnh֘At
// 		:hSocket - \Pbgnh
// ߂l	:Ȃ
//
void CSock::Attach( SOCKET hSocket )
{
	m_hSocket = hSocket;
}

//
// O		:void CSock::Detach()
// @\		:õ\Pbgnh
// 		:Ȃ
// ߂l	:Ȃ
//
void CSock::Detach()
{
	if( m_hSocket != INVALID_SOCKET )
	{
		shutdown( m_hSocket, 0x02 );
		closesocket( m_hSocket );
		m_hSocket = INVALID_SOCKET;
	}
}

//
// O		:bool CSock::Socket( int nAddrFamily, int nSocketType, int nProtocol )
// @\		:V\Pbgnh쐬
// 		:nAddrFamily - AhXt@~
//			:nSocketType - \Pbg̎
//			:nProtocol - vgR
// ߂l	: - true s - false
//
bool CSock::Socket( int nAddrFamily, int nSocketType, int nProtocol )
{
	m_hSocket = socket( nAddrFamily, nSocketType, nProtocol );
	if( m_hSocket == INVALID_SOCKET ){return false;}
	return true;
}

//
// O		:bool CSock::Bind( CSockAddr *addr )
// @\		:\Pbg̃AhXɃoCh
// 		:*addr - oChAhXێCX^X̃|C^
// ߂l	: - true s - false
//
bool CSock::Bind( LPCTSTR lpszIP, int nPort )
{
	this->m_InetSockAddrFrom.sin_addr.s_addr = inet_addr( lpszIP );
	this->m_InetSockAddrFrom.sin_port = htons( (u_short)nPort );
	this->m_InetSockAddrFrom.sin_family = AF_INET;

	if( m_hSocket == INVALID_SOCKET ){return false;}

	if( bind( m_hSocket, (struct sockaddr*)&m_InetSockAddrFrom, sizeof( sockaddr_in ) ) == SOCKET_ERROR )
		return false;
	return true;
}

//
// O		:bool CSock::Bind( CSockAddr *addr )
// @\		:\Pbg̃AhXɃoCh
// 		:*addr - oChAhXێCX^X̃|C^
// ߂l	: - true s - false
//
bool CSock::Listen( int nMaxCon )
{
	if( m_hSocket == INVALID_SOCKET ||
		nMaxCon < 1
		){return false;}

	if( listen( m_hSocket, nMaxCon ) == SOCKET_ERROR )
		return false;
	return true;
}

//
// O		:bool CSock::Accept( CSock &sock )
// @\		:̃\PbgŐڑṽANZvg
// 		:&sock - ANZvgp̃\Pbg
// ߂l	: - TRUE s - FALSE
//
bool CSock::Accept( CSock &sock )
{
	if( m_hSocket == INVALID_SOCKET ){return FALSE;}

	int nSize = sizeof( sockaddr );
	SOCKET hSocket = accept( m_hSocket, NULL, &nSize );

	if( hSocket != INVALID_SOCKET )
	{
		sock.Attach( hSocket );
		return true;
	}
	return false;
}

//
// O		:bool CSock::Connect( CSockAddr *addr )
// @\		:̃AhXɐڑ
// 		:*addr - ڑAhXێCX^X̃|C^
// ߂l	: - true s - false
//
bool CSock::Connect( LPCTSTR lpszIP, int nPort )
{
	this->m_InetSockAddrTo.sin_addr.s_addr = inet_addr( lpszIP );
	this->m_InetSockAddrTo.sin_port = htons( (u_short)nPort );
	this->m_InetSockAddrTo.sin_family = AF_INET;

	if( m_hSocket == INVALID_SOCKET ){return false;}

	if( connect( m_hSocket, (struct sockaddr*)&m_InetSockAddrTo, sizeof( sockaddr_in ) ) == SOCKET_ERROR )
		return false;
	return true;
}

//
// O		:void CSock::Detach()
// @\		:õ\Pbgnh
// 		:
// ߂l	:
//
void CSock::Close()
{
	shutdown( m_hSocket, 0x02 );
	closesocket( m_hSocket );
	m_hSocket = INVALID_SOCKET;
}

//
// O		:int CSock::Send( const char *szMsg, int nByte )
// @\		:sMsgnByteoCg
// 		:sMsg - Mobt@̃|C^
//			:nByte - oCg
// ߂l	:ۂɑꂽoCg
//
int CSock::Send( const char *szMsg, size_t nByte )
{
	if( m_hSocket == INVALID_SOCKET ){return 0;}
	return send( m_hSocket, szMsg, nByte, 0 );
}

//
// O		:int CSock::Recv( char *szBuff )
// @\		:MāAsBuffɊi[
// 		:szBuff - Mpobt@̃|C^
// ߂l	:MoCg
//
int CSock::Recv( char *szBuff )
{
	if( m_hSocket == INVALID_SOCKET ){return 0;}
	return recv( m_hSocket, szBuff, RECV_BUFFER_SIZE, 0 );
}

//
// O		:bool CSock::Detach()
// @\		:õ\PbgnhLׂ
// 		:
// ߂l	:L - true  - false
//
bool CSock::IsValid()
{
	if( m_hSocket == INVALID_SOCKET ){return false;}
	return true;
}
