// XISLDialogTag.h: CXISLDialogTag NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_XISLDIALOGTAG_H__0B08BB6F_5627_4711_983E_1D48D33B3987__INCLUDED_)
#define AFX_XISLDIALOGTAG_H__0B08BB6F_5627_4711_983E_1D48D33B3987__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "XISLTag.h"
#include "XISLBeginTag.h"
#include "XISLVariable.h"
#include "XISLVarList.h"

class CXISLCombExchangeTag;
class CXISLExchangeTag;
class CXISLDialogDlg;
class CXISLCallTag;

class CXISLDialogTag : public CXISLTag  
{
	friend class CXISLDialogDlg;
//<dialog>̑
protected:
	int m_nScope;
	int m_nRepeat;
	int m_nComb;
	CString m_strID;
protected:
	CString m_strWindowID;
	CString m_strURI;
	BOOL m_bValid;
	BOOL m_bDummy;
	CString m_strDummyDocName;
	int m_nDummyArgCount;

public:
	//<dialog_var>,<exchange>,<(par/alt/seq)_exchange>,<begin>,<end>̃Xg
	CPtrList m_ExchangeList;
	CXISLBeginEndTag * m_pEnd;
	CXISLBeginEndTag * m_pBegin;
//	CXISLVariable m_argVar;
	CXISLVarList *m_pDialogVar;
	CPtrList m_ArgList;

	CPtrList m_NextList;
	CPtrList m_ReCallList;

//OC^tF[X
public:
	void SetBrowserData(LPCTSTR lpszURI,LPCTSTR lpszWID){m_strURI = lpszURI;m_strWindowID = lpszWID;}
	BOOL IsModalWindowUsed(CString &strURI,CString &strWID);
	BOOL IsValid(){return m_bValid;}
	BOOL IsDummy(){return m_bDummy;}
	void SetDummy(int nDummyArgCount,LPCTSTR lpszDummyDocName);
	int ResetArgVar();
	BOOL IsSubDialog();
	BOOL AddReCallTag(CXISLCallTag *pTag);
	BOOL RemoveReCallTag(CXISLCallTag *pTag);
	int GetReCallTagCount(){return m_ReCallList.GetCount();}
	int GetReCallReturnCount();
	void SetCmb4ReCallTag(CComboBox &cmbCtrl);
	void SetArgVarList2LBox(CListCtrl &lbCtrl);

	int RemoveDialogArg(CXISLVar *pVar);
	int RegistDialogArg(CXISLVar *pVar);
	int SetDialogAttribute(LPCTSTR lpszID,int nComb,int nRepeat,int nScope);
	int SetDialogAttribute(LPCTSTR lpszID,LPCTSTR lpszComb,LPCTSTR lpszRepeat,LPCTSTR lpszScope,LPCTSTR lpszArg);
	LPCTSTR GetDialogID(){return m_strID;}
	void GetDialogArg(CString &strArg){m_pDialogVar->GetVarNameList(strArg);}
	int GetDialogArgCount();
	int GetDialogScope(){return m_nScope;}
	int GetDialogRepeat(){return m_nRepeat;}
	int GetDialogComb(){return m_nComb;}
	void SetDocName(LPCTSTR lpszDocName);
	LPCTSTR GetDocName();

public:
	CXISLTag* FindTag(POINT point,BOOL bOnly=FALSE);
	CSize DrawXISLFlow(CDC *pDC,int nX=0,int nY=0);
	BOOL RegistXISLTree(CTreeCtrl *pTree,HTREEITEM hParent);
	CXISLCombExchangeTag* InsertCombExchange(CXISLCombExchangeTag *pCombExcTag,CXISLTag *pPlaceTag=NULL);
	CXISLCombExchangeTag* InsertCombExchange(int nCombType,CXISLTag *pPlaceTag=NULL);
	CXISLExchangeTag* InsertExchange(CXISLExchangeTag *pExcTag,CXISLTag *pPlaceTag=NULL);
	CXISLExchangeTag* InsertExchange(int nComb,LPCTSTR lpszURI="",CXISLTag *pPlaceTag=NULL);
	BOOL DeleteExchange(CXISLExchangeTag *pETag);
	BOOL DeleteCombExchange(CXISLCombExchangeTag *pCExcTag);
	CXISLBeginEndTag* CreateBegin();
	void DestroyBegin();
	CXISLBeginEndTag* CreateEnd();
	void DestroyEnd();
	void DeleteAll();
	LPCTSTR GetXISLString();
	int GetItemCount();

public:
	CXISLDialogTag();
//	CXISLDialogTag(CXISLTag *pParent,LPCTSTR lpszID,int nComb,int nRepeat,int nScope,LPCTSTR lpszArg);
	virtual ~CXISLDialogTag();
	CXISLDialogTag(const CXISLDialogTag &cpXISL); //RsR
	CXISLDialogTag & operator=(const CXISLDialogTag &cpXISL);
};

#endif // !defined(AFX_XISLDIALOGTAG_H__0B08BB6F_5627_4711_983E_1D48D33B3987__INCLUDED_)
