// XISLVar.cpp: CXISLVar NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ib.h"
#include "XISLVar.h"
#include "XISLVarList.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CXISLVar::CXISLVar()
{
	m_nReferCount = 0;
	m_pParent = NULL;
	m_bDeclare = TRUE;
	m_bDummy = FALSE;
}

CXISLVar::~CXISLVar()
{
	m_pParent = NULL;
}

CXISLVar::CXISLVar(const CXISLVar &cpXISL)
{
	m_nReferCount = cpXISL.m_nReferCount;
	m_strName = cpXISL.m_strName;
	m_strExpr = cpXISL.m_strExpr;
	m_pParent = cpXISL.m_pParent;
	m_bDeclare = cpXISL.m_bDeclare;
	m_bDummy = cpXISL.m_bDummy;
}

CXISLVar& CXISLVar::operator=(const CXISLVar &cpXISL)
{
	if(&cpXISL != this)
	{
		m_nReferCount = cpXISL.m_nReferCount;
		m_strName = cpXISL.m_strName;
		m_strExpr = cpXISL.m_strExpr;
		m_pParent = cpXISL.m_pParent;
		m_bDeclare = cpXISL.m_bDeclare;
		m_bDummy = cpXISL.m_bDummy;
	}
	return *this;
}

void CXISLVar::ReferCount(BOOL bAdd)
{
	if(bAdd)
		m_nReferCount++;
	else 
	{
		if(m_nReferCount > 1)
			m_nReferCount--;
		else
			ASSERT(NULL);
	}
}

int CXISLVar::SetAttribute(LPCTSTR lpszName,LPCTSTR lpszExpr,BOOL bDeclare,BOOL bDummy)
{
	if(!bDummy)
	{
		// ϐ̒
		int nCount = 0;
		// Pڂ̃`FbN
		if(	((lpszName[nCount] >= 'a')&&(lpszName[nCount] <= 'z'))||
			((lpszName[nCount] >= 'A')&&(lpszName[nCount] <= 'Z')) )
		{
			nCount++;
			// Qڈȍ~̃`FbN
			while(	((lpszName[nCount] >= 'a')&&(lpszName[nCount] <= 'z'))||
					((lpszName[nCount] >= 'A')&&(lpszName[nCount] <= 'Z'))||
					((lpszName[nCount] >= '0')&&(lpszName[nCount] <= '9'))||
					(lpszName[nCount] == '_'))
			{
				// ϐɎgȂo邽߂̃[v
				nCount ++;
			}
			if(lpszName[nCount] != '\0')
			{
				AfxMessageBox("ϐsłD",
					MB_OK|MB_APPLMODAL|MB_ICONINFORMATION,0);
				return -1;
			}
		}
		else
		{
			AfxMessageBox("ϐsłD",
					MB_OK|MB_APPLMODAL|MB_ICONINFORMATION,0);
			return -1;
		}
	}

	m_strName = lpszName;
	m_strExpr = lpszExpr;
	m_bDeclare = bDeclare;
	m_bDummy = bDummy;

	return 0;
}

//XR[vt̕ϐԂ
void CXISLVar::GetVarNameEx(CString &strName)
{
	strName = m_strName;
	if(m_bDummy)
		return;

	int nScope = m_pParent->GetScope();
	if(nScope != ID_VARSCOPE_EXCHANGE && nScope != ID_VARSCOPE_LOCAL)
	{
		strName.Insert(0,".");
		strName.Insert(0,XISL_VARSCOPE2[nScope]);
	}
}

